<?php

/**
 * Description of MCList
 *
 * @author Arian Khosravi <arian@bigemployee.com>, <@ArianKhosravi>
 */
class MCList {

    protected $_id;
    protected $_api_key;
    protected $_list_id;

    function __construct(array $options = null) {
        if (is_array($options))
            $this->setOptions($options);
    }

    function __set($name, $value) {
        $method = 'set' . $name;
        if ('mapper' == $name || !method_exists($this, $method))
            throw new Exception('Invalid method ' . $method);

        $this->$method($value);
    }

    function __get($name) {
        $method = 'get' . $name;
        if ('mapper' == $name || !method_exists($this, $method))
            throw new Exception('Invalid method ' . $method);

        return $this->$method();
    }

    function setOptions(array $options = null) {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods))
                $this->$method($value);
        }
        return $this;
    }

    public function getId() {
        return $this->_id;
    }

    public function setId($id) {
        $this->_id = $id;
        return $this;
    }

    public function getApi_key() {
        return $this->_api_key;
    }

    public function setApi_key($api_key) {
        $this->_api_key = $api_key;
        return $this;
    }

    public function getList_id() {
        return $this->_list_id;
    }

    public function setList_id($list_id) {
        $this->_list_id = $list_id;
        return $this;
    }
}

?>