<?php
/**
 * Description of MCListMapper
 *
 * @author Arian Khosravi <arian@bigemployee.com>, <@ArianKhosravi>
 */
class MCListMapper {

    protected $_dbTable;

    public function setDbTable($dbTable) {
        global $wpdb;
        $this->_dbTable = $wpdb->prefix . $dbTable;
        return $this;
    }

    public function getDbTable() {
        if (null === $this->_dbTable) {
            $this->setDbTable('big_mailchimp_lists');
        }
        return $this->_dbTable;
    }

    public function save(MCList $mcList) {
        global $wpdb;
        $data = array(
            'api_key' => $mcList->getApi_key(),
            'list_id' => $mcList->getList_id()
        );
        if (null === ($id = $mcList->getId())) {
            unset($data['id']);
            return $wpdb->insert($this->getDbTable(), $data);
        } else {
            return $wpdb->update($this->getDbTable(), $data, array('id' => $mcList->getId()));
        }
    }

    public function find($id, MCList $mcList) {
        global $wpdb;
        $row = $wpdb->get_row("SELECT * FROM " . $this->getDbTable() . " WHERE id =$id");
        if (count($row)) {
            $mcList->setId($row->id)
                    ->setApi_key($row->api_key)
                    ->setList_id($row->list_id);
            return $mcList;
        }

        return;
    }

    public function fetchAll() {
        global $wpdb;
        $resultSet = $wpdb->get_results("SELECT * FROM " . $this->getDbTable());
        $entries = array();
        foreach ($resultSet as $row) {
            $entry = new MCList();
            $entry->setId($row->id)
                    ->setApi_key($row->api_key)
                    ->setList_id($row->list_id);
            $entries[] = $entry;
        }
        return $entries;
    }

    public function remove($id) {
        global $wpdb;
        return $wpdb->query("DELETE FROM " . $this->getDbTable() . " WHERE id = '" . $id . "'");
    }

}

?>